package gui;
import javax.swing.*;
import java.awt.*;
import simulation.Elevator;
import commandSystem.Direction;


@SuppressWarnings("serial")
class ElevatorCanvas extends JPanel {
	private final static int WIDTH = 40;
	private final static int HEIGHT = 50;
	private final static Dimension DIMENSIONS = new Dimension(WIDTH, 200);

	private Elevator elevator;

	public ElevatorCanvas(Elevator elevator) {
		this.elevator = elevator;
	}

    @Override
    public Dimension getMinimumSize() {
		return DIMENSIONS;
    }
    @Override
    public Dimension getPreferredSize() {
		return DIMENSIONS;
    }
    @Override
    public Dimension getMaximumSize() {
		return DIMENSIONS;
    }

    @Override
    public void paintComponent(Graphics g) {
		super.paintComponent(g);
		if (elevator.getStoppingNextFloor()) {
			g.setColor(Color.BLUE);
		}
		else if (elevator.getDirection() == Direction.NONE) {
			g.setColor(Color.GRAY);
		}
		else if (elevator.getEmergency()) {
			g.setColor(Color.RED);
		}
		else {
			g.setColor(Color.BLACK);
		}
		// g.fillRect(0, 200 - (int) Math.floor(elevator.getHeight() * 200) - HEIGHT, WIDTH, HEIGHT);
		// System.out.println("elevator height:" + elevator.getHeight());
		g.fillRect(0, 200 - HEIGHT - (int) ((200 - HEIGHT) * elevator.getHeight()), WIDTH, HEIGHT);

		Toolkit.getDefaultToolkit().sync();
    }
}
